#! /usr/bin/perl
use warnings;
use strict;

if(@ARGV < 1) { die "perl $0 file\n"; }

my($line) 	= "";
my(@cols1)	= ();
my(@cols2)	= ();
my($seq)	= "";
my($id)		= "";
my(%hash1)	= ();
my(%hash2)	= ();
my($counter)	= 0;
my($hkey)	= "";
my($rkey)	= "";

open(IN, $ARGV[0]) or die "$ARGV[0] not opened\n";
while($line = <IN>) {
	$line =~ s/^\s+|\s+$//g;

	if($line =~ m/^>/) {
		$line =~ s/^>//g;
		@cols1 = split(/\;/, $line);
		@cols2 = split(/\s+/, $cols1[0]);	
		if(defined($cols2[1])) { 
			$id = $cols2[1];
		} else {
			$id = $cols2[0];
		}

		$hkey = "$counter $id";
		$rkey = "$id\t$id, $cols1[1], $cols1[2]"; 

		$hash1{"$hkey"}{'seq'} = "";
		$hash1{"$hkey"}{'len'} = 0;
		$hash1{"$hkey"}{'id'}  = "$rkey";		

		++$counter;
	} else {
		$hash1{"$hkey"}{'seq'} .= $line;
		$hash1{"$hkey"}{'len'} += length($line);
	}
};
close IN;

for my $key (sort { $hash1{$a}{'len'} <=> $hash1{$b}{'len'}; } (keys(%hash1))) {
	$id			= $key;
	$id			=~ s/^\d+\s//g;
	$hash2{$id}{'seq'}	= $hash1{$key}{'seq'};
	$hash2{$id}{'id'}	= $hash1{$key}{'id'};

	#print STDERR "$id $hash1{$key}{'seq'}\n";
};

for my $key (keys(%hash2)) {
	print "NULL\t$hash2{$key}{'id'}\t$hash2{$key}{'seq'}\n";
}

######################################EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
#mysql -u matti -p matti
#use matti;
#
#CREATE TABLE arabidopsis_thaliana_nocds LIKE arabidopsis_thaliana_clean;
#
#LOAD DATA LOCAL INFILE 'athaliana_upstream3000_nocds.tab' INTO TABLE arabidopsis_thaliana_nocds
#
#INSERT into promoter_information (Data, Date) VALUES('arabidopsis_thaliana_nocds', '11_06_2012' );
#




